#ifndef __RDS01_H__
#define __RDS01_H__

typedef struct _rds01_ctx
{
  int                    Minor;
  struct cdev           *pCharDev;
  struct device         *pClassDev;
  int                    IsOpen;
  int                    IsRemoved;
  struct usb_device     *udev;			/* the usb device for this device */
  struct usb_interface  *interface;		/* the interface for this device */
  
#if 0    
  struct urb             *bulk_in_urb;		/* the urb to read data with */
  __u8                   *bulk_in_buffer;	/* the buffer to receive data */
  __u32                  bulk_in_size;		/* the size of the receive buffer */
  __u32                  bulk_in_filled;		/* number of bytes in the buffer */
  size_t                 bulk_in_copied;		/* already copied to user space */
  __u8                   bulk_in_endpointAddr;	/* the address of the bulk in endpoint */
  __u8                   bulk_out_endpointAddr;	/* the address of the bulk out endpoint */
  int                    errors;			/* the last request tanked */
  int                    ongoing_read;		/* a read is going on */
  spinlock_t             err_lock;		/* lock for errors */
  struct kref            kref;
  struct mutex           io_mutex;		/* synchronize I/O with disconnect */
  wait_queue_head_t	     bulk_in_wait;		/* to wait for an ongoing read */
#endif
  struct kref	  	 kref;
  u32                    bIn_size;
  u8                     bIn_Addr;
  u32                    bOut_size;
  u8                     bOut_Addr;
  u8                    *pInBuffer;
  u8                    *pOutBuffer;
  u8                    *pCtrlBuffer;
  struct urb            *pTXUrb;
  struct urb            *pRXUrb;
  int                   IsIOPending;
  //wait_queue_head_t	    IOPendingQ;
  int                   IOStatus;
  int                   BytesRead;
  
  u8                   *pTXWrkBuffer;
  u8                   *pRXWrkBuffer;
  
  u8                   *pTXBlockBuffer;
  u8                   *pRXBlockBuffer;
  u8                   *pWriteBuffer;
  u32                  CurOffset;
  u8                  *pDMACtrlBuf;
  u8                  *pTmpRXBuf;
}RDS_01_CTX,*PRDS_01_CTX;

PRDS_01_CTX PrivFindDevCtx(int Minor);

void dumpData(char*Prefix,u8 *pData,u32 DataSize);
void priv_dev_delete(struct kref *kref);

int pl2303_init(PRDS_01_CTX pDev);
int pl2303_open(PRDS_01_CTX pDev);
int pl2303_write(PRDS_01_CTX pDev,u8 *pBuffer,int BufSize);
int pl2303_read(PRDS_01_CTX pDev,u8 *pBuffer,int BufSize);
int pl2303_set_speed(PRDS_01_CTX pDev,u32 Speed);
#endif

